<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\master_worker;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\master_worker\MasterWorkerAccountLog;
use app\common\model\property\PropertyHead;
use app\common\model\property\PropertyOrder;
use app\common\lists\ListsSearchInterface;
use app\common\model\works\ServiceWork;
use think\facade\Db;


/**
 * MoneyAnalysis列表
 * Class MoneyAnalysis
 * @package app\adminapi\lists
 */
class MoneyAnalysis extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function setSearch(): array
    {
        return [
        ];
    }
    public function queryWhere()
    {
        $where = [];
        /*$tmpWhere = [];
        $workIds = [];
        isset($this->params['property_name']) && !empty($this->params['property_name']) && $tmpWhere[] = ['property_name', 'LIKE', '%'.$this->params['property_name'].'%'];
        isset($this->params['village_name']) && !empty($this->params['village_name']) && $tmpWhere[] = ['village_name', 'LIKE', '%'.$this->params['village_name'].'%'];
        isset($this->params['head_name']) && !empty($this->params['head_name']) && $tmpWhere[] = ['head_name', 'LIKE', '%'.$this->params['head_name'].'%'];
        isset($this->params['head_mobile']) && !empty($this->params['head_mobile']) && $tmpWhere[] = ['head_mobile', '=', $this->params['head_mobile']];
        if(!empty($tmpWhere)){
            $property_head_ids = PropertyHead::where($tmpWhere)->column('id');
            $property_head_ids && $workIds = PropertyOrder::where('order_status',3)->where('property_head_id','IN',$property_head_ids)->column('work_id');
        }else{
            $workIds = PropertyOrder::where('order_status',3)->column('work_id');
        }*/
        if(isset($this->params['start_month']) && $this->params['start_month']){
            $startDateTime = strtotime($this->params['start_month']);
            $endDateTime = strtotime('+1 month', $startDateTime)-1;
            $where[] = ['create_time','BETWEEN',[$startDateTime,$endDateTime]];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function lists(): array
    {
        return MasterWorkerAccountLog::with(['masterWorker'])->where($this->queryWhere())
            ->field(Db::raw('worker_id,action,DATE_FORMAT(FROM_UNIXTIME(create_time), "%Y-%m") AS month_format,COUNT(id) as month_num, SUM(change_amount) as month_amount'))
            ->group('worker_id,action,month_format') //action
            ->limit($this->limitOffset, $this->limitLength)
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function count(): int
    {
        return MasterWorkerAccountLog::with(['masterWorker'])->where($this->queryWhere())
            ->field(Db::raw('worker_id,DATE_FORMAT(FROM_UNIXTIME(create_time), "%Y-%m") AS month_format,COUNT(id) as month_num, SUM(change_amount) as month_amount'))
            ->group('worker_id,month_format')
            ->count();
    }

}